<?php

/**
  * SquirrelMail Change User Password Plugin
  * @copyright 2012 The SquirrelMail Project Team
  * @license http://opensource.org/licenses/gpl-license.php GNU Public License
  * @version $Id$
  * @package plugins
  * @subpackage change_user_passwd
  * @author Philippe-A. Bourdin, http://www.Bourdin.ch/Philippe/
  */


	global $min_pass_length;
	global $max_pass_length;

	define('SM_PATH', '../../');

	include_once(SM_PATH . 'include/validate.php');
	include_once(SM_PATH . 'functions/global.php');
	include_once(SM_PATH . 'plugins/change_user_passwd/config.php');


	displayPageHeader($color, 'None');

	sqGetGlobalVar('username', $username, SQ_SESSION);
	sqGetGlobalVar('base_uri', $base_uri, SQ_SESSION);

	$old_pass = $_POST['old_pass'];
	$new_pass = $_POST['new_pass'];
	$new_copy = $_POST['new_copy'];


	if (!isset($color) || !is_array($color)) {
		$color = array();
		$color[0]  = '#dcdcdc';  /* light gray    TitleBar               */
		$color[1]  = '#800000';  /* red                                  */
		$color[2]  = '#cc0000';  /* light red     Warning/Error Messages */
		$color[3]  = '#a0b8c8';
		$color[4]  = '#ffffff';  /* white         Normal Background      */
		$color[7]  = '#0000cc';  /* blue          Links                  */
		$color[8]  = '#000000';  /* black         Normal text            */
		$color[9]  = '#ababab';
	}
	if (!$color[17]) {
		$color[17] = '#ceddf2';  /* light blue    Login Background       */
	}

	if (!$max_pass_length) { $max_pass_length = $min_pass_length*4; }

	// consistency checks
	$msg = '';
	if (empty($username)) {
		$msg = _("Empty username") . '!<br />';
		$msg .=  _("Please contact your system administrator and report this error.");
	}
	elseif (empty($old_pass)) {
		$msg = _("You must type in your current password.");
	}
	elseif (empty($new_pass)) {
		$msg = _("You must type in a new password.");
	}
	elseif (empty($new_copy)) {
		$msg = _("You must also type in your new password in the verify box.");
	}
	elseif ($new_pass != $new_copy) {
		$msg = _("Your new password does not match the verify password.");
	}
	elseif ($old_pass == $new_pass) {
		$msg = _("No changes requested.");
	}
	elseif ((strlen ($new_pass) < $min_pass_length) || (strlen ($new_pass) > $max_pass_length)) {
		$msg = _("Your new password should be %s to %s characters long.");
		$msg = sprintf ($msg, $min_pass_length, $max_pass_length);
	}
	else {

		// safety first
		$arg_user = escapeshellarg($username);
		$arg_old = escapeshellarg($old_pass);
		$arg_new = escapeshellarg($new_pass);

		// perform password change
		$exec_cmd = './change_user_passwd.sh ' . $arg_user . ' ' . $arg_old . ' ' . $arg_new;
		if (strpos ($exec_cmd, "\n") !== FALSE) {
			$msg = _("Your new password contains invalid characters.");
		}
		else {
			$result = exec($exec_cmd);
			$result = preg_replace ("/^.*?\\[sudo\\] password for [^:\\n]*:\\s*/is", '', $result);
			if ($result == "E1") {
				$msg = _("Cannot change password!");
			}
			elseif ($result == "E2") {
				$msg = _("Your current password is not correct.");
			}
			elseif ($result == "E3") {
				$msg = sprintf(_("User \"%s\" does not exist"), $username);
			}
			elseif ($result != "OK") {
				$msg = _("Password change was not successful!");
				$msg .= '<br /><b>' . htmlentities($result) . '</b>';
			}
		}
	}

	if (empty ($msg)) {

		sq_change_text_domain('change_pass');
		$msg = htmlentities (_("Password changed successfully."));
		$key = sqauth_save_password($new_pass);
		sq_change_text_domain('squirrelmail');
	}
	else {
		$msg = '<font color="' . $color[2] . '">' . _("ERROR") . ': ' . $msg . '</font>';
	}
?>
<br />
<table bgcolor="<?php echo $color[17] ?>" align="center" border="0" cellpadding="2" cellspacing="0">
  <tr>
    <td align="center" bgcolor="<?php echo $color[3] ?>"><b><?php echo _("Change Password"); ?></b></td>
  </tr>
  <tr>
    <td align="center"><?php echo $msg; ?></td>
  </tr>
  <tr>
    <td align="center">
      <form method="get" action="../../src/options.php">
      <input type="submit" value="<?php echo _("Return to options page"); ?>">
      </form>
    </td>
  </tr>
</table>
</body>
</html>
