<?php

/**
  * SquirrelMail Change User Password Plugin
  * @copyright 2012 The SquirrelMail Project Team
  * @license http://opensource.org/licenses/gpl-license.php GNU Public License
  * @version $Id$
  * @package plugins
  * @subpackage change_user_passwd
  * @author Philippe-A. Bourdin, http://www.Bourdin.ch/Philippe/
  */

if (!defined('SM_PATH')) define('SM_PATH', '../../');

/**
  * Register this plugin with SquirrelMail
  * 
  * @return void
  *
  */
function squirrelmail_plugin_init_change_user_passwd() {

    global $squirrelmail_plugin_hooks;

    $squirrelmail_plugin_hooks['optpage_register_block']['change_user_passwd']
        = 'change_user_passwd_plugin_optpage_register_block';

}


/**
  * Add register to the options page
  *
  * @return void
  *
  */
function change_user_passwd_plugin_optpage_register_block() {

    include_once(SM_PATH . 'plugins/change_user_passwd/functions.php');
    change_user_passwd_plugin_optpage_register_block_do();

}


/**
  * Returns info about this plugin
  *
  * @return array An array of plugin information.
  *
  */
function change_user_passwd_info()
{

    return array(
        'english_name' => 'Change User Password',
        'version' => '1.0',
        'summary' => "Squirrelmail plugin to change the password of a regular system user using the POSIX commands.",
        'details' => "This minimalistic Squirrelmail plugin allows users to change their password using the POSIX command 'passwd' and 'sudo', the user is not required to have a regular login-shell.",
        'requires_configuration' => 0,
        'requires_source_patch' => 0,
    );

}


/**
  * Returns version info about this plugin
  *
  */
function change_user_passwd_version()
{

   $info = change_user_passwd_info();
   return $info['version'];

}
